/* Software License Agreement (BSD License)
 *
 * Copyright (c) 2011, Willow Garage, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials provided
 *    with the distribution.
 *  * Neither the name of Willow Garage, Inc. nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * Auto-generated by genmsg_cpp from file /tmp/buildd/ros-hydro-manipulation-msgs-0.2.0-0precise-20150327-1930/msg/GraspResult.msg
 *
 */


#ifndef MANIPULATION_MSGS_MESSAGE_GRASPRESULT_H
#define MANIPULATION_MSGS_MESSAGE_GRASPRESULT_H


#include <string>
#include <vector>
#include <map>

#include <ros/types.h>
#include <ros/serialization.h>
#include <ros/builtin_message_traits.h>
#include <ros/message_operations.h>


namespace manipulation_msgs
{
template <class ContainerAllocator>
struct GraspResult_
{
  typedef GraspResult_<ContainerAllocator> Type;

  GraspResult_()
    : result_code(0)
    , continuation_possible(false)  {
    }
  GraspResult_(const ContainerAllocator& _alloc)
    : result_code(0)
    , continuation_possible(false)  {
    }



   typedef int32_t _result_code_type;
  _result_code_type result_code;

   typedef uint8_t _continuation_possible_type;
  _continuation_possible_type continuation_possible;


    enum { SUCCESS = 1 };
     enum { GRASP_OUT_OF_REACH = 2 };
     enum { GRASP_IN_COLLISION = 3 };
     enum { GRASP_UNFEASIBLE = 4 };
     enum { PREGRASP_OUT_OF_REACH = 5 };
     enum { PREGRASP_IN_COLLISION = 6 };
     enum { PREGRASP_UNFEASIBLE = 7 };
     enum { LIFT_OUT_OF_REACH = 8 };
     enum { LIFT_IN_COLLISION = 9 };
     enum { LIFT_UNFEASIBLE = 10 };
     enum { MOVE_ARM_FAILED = 11 };
     enum { GRASP_FAILED = 12 };
     enum { LIFT_FAILED = 13 };
     enum { RETREAT_FAILED = 14 };
 

  typedef boost::shared_ptr< ::manipulation_msgs::GraspResult_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::manipulation_msgs::GraspResult_<ContainerAllocator> const> ConstPtr;
  boost::shared_ptr<std::map<std::string, std::string> > __connection_header;

}; // struct GraspResult_

typedef ::manipulation_msgs::GraspResult_<std::allocator<void> > GraspResult;

typedef boost::shared_ptr< ::manipulation_msgs::GraspResult > GraspResultPtr;
typedef boost::shared_ptr< ::manipulation_msgs::GraspResult const> GraspResultConstPtr;

// constants requiring out of line definition

   

   

   

   

   

   

   

   

   

   

   

   

   

   



template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const ::manipulation_msgs::GraspResult_<ContainerAllocator> & v)
{
ros::message_operations::Printer< ::manipulation_msgs::GraspResult_<ContainerAllocator> >::stream(s, "", v);
return s;
}

} // namespace manipulation_msgs

namespace ros
{
namespace message_traits
{



// BOOLTRAITS {'IsFixedSize': True, 'IsMessage': True, 'HasHeader': False}
// {'household_objects_database_msgs': ['/opt/ros/hydro/share/household_objects_database_msgs/cmake/../msg'], 'shape_msgs': ['/opt/ros/hydro/share/shape_msgs/cmake/../msg'], 'std_msgs': ['/opt/ros/hydro/share/std_msgs/cmake/../msg'], 'actionlib_msgs': ['/opt/ros/hydro/share/actionlib_msgs/cmake/../msg'], 'sensor_msgs': ['/opt/ros/hydro/share/sensor_msgs/cmake/../msg'], 'object_recognition_msgs': ['/opt/ros/hydro/share/object_recognition_msgs/cmake/../msg'], 'geometry_msgs': ['/opt/ros/hydro/share/geometry_msgs/cmake/../msg'], 'manipulation_msgs': ['/tmp/buildd/ros-hydro-manipulation-msgs-0.2.0-0precise-20150327-1930/msg', '/tmp/buildd/ros-hydro-manipulation-msgs-0.2.0-0precise-20150327-1930/obj-x86_64-linux-gnu/devel/share/manipulation_msgs/msg']}

// !!!!!!!!!!! ['__class__', '__delattr__', '__dict__', '__doc__', '__eq__', '__format__', '__getattribute__', '__hash__', '__init__', '__module__', '__ne__', '__new__', '__reduce__', '__reduce_ex__', '__repr__', '__setattr__', '__sizeof__', '__str__', '__subclasshook__', '__weakref__', '_parsed_fields', 'constants', 'fields', 'full_name', 'has_header', 'header_present', 'names', 'package', 'parsed_fields', 'short_name', 'text', 'types']




template <class ContainerAllocator>
struct IsFixedSize< ::manipulation_msgs::GraspResult_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::manipulation_msgs::GraspResult_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::manipulation_msgs::GraspResult_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::manipulation_msgs::GraspResult_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::manipulation_msgs::GraspResult_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct HasHeader< ::manipulation_msgs::GraspResult_<ContainerAllocator> const>
  : FalseType
  { };


template<class ContainerAllocator>
struct MD5Sum< ::manipulation_msgs::GraspResult_<ContainerAllocator> >
{
  static const char* value()
  {
    return "c8a909da895cdddc0630aafd59848191";
  }

  static const char* value(const ::manipulation_msgs::GraspResult_<ContainerAllocator>&) { return value(); }
  static const uint64_t static_value1 = 0xc8a909da895cdddcULL;
  static const uint64_t static_value2 = 0x0630aafd59848191ULL;
};

template<class ContainerAllocator>
struct DataType< ::manipulation_msgs::GraspResult_<ContainerAllocator> >
{
  static const char* value()
  {
    return "manipulation_msgs/GraspResult";
  }

  static const char* value(const ::manipulation_msgs::GraspResult_<ContainerAllocator>&) { return value(); }
};

template<class ContainerAllocator>
struct Definition< ::manipulation_msgs::GraspResult_<ContainerAllocator> >
{
  static const char* value()
  {
    return "int32 SUCCESS = 1\n\
int32 GRASP_OUT_OF_REACH = 2\n\
int32 GRASP_IN_COLLISION = 3\n\
int32 GRASP_UNFEASIBLE = 4\n\
int32 PREGRASP_OUT_OF_REACH = 5\n\
int32 PREGRASP_IN_COLLISION = 6\n\
int32 PREGRASP_UNFEASIBLE = 7\n\
int32 LIFT_OUT_OF_REACH = 8\n\
int32 LIFT_IN_COLLISION = 9\n\
int32 LIFT_UNFEASIBLE = 10\n\
int32 MOVE_ARM_FAILED = 11\n\
int32 GRASP_FAILED = 12\n\
int32 LIFT_FAILED = 13\n\
int32 RETREAT_FAILED = 14\n\
int32 result_code\n\
\n\
# whether the state of the world was disturbed by this attempt. generally, this flag\n\
# shows if another task can be attempted, or a new sensed world model is recommeded\n\
# before proceeding\n\
bool continuation_possible\n\
";
  }

  static const char* value(const ::manipulation_msgs::GraspResult_<ContainerAllocator>&) { return value(); }
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

  template<class ContainerAllocator> struct Serializer< ::manipulation_msgs::GraspResult_<ContainerAllocator> >
  {
    template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
    {
      stream.next(m.result_code);
      stream.next(m.continuation_possible);
    }

    ROS_DECLARE_ALLINONE_SERIALIZER;
  }; // struct GraspResult_

} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::manipulation_msgs::GraspResult_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const ::manipulation_msgs::GraspResult_<ContainerAllocator>& v)
  {
    s << indent << "result_code: ";
    Printer<int32_t>::stream(s, indent + "  ", v.result_code);
    s << indent << "continuation_possible: ";
    Printer<uint8_t>::stream(s, indent + "  ", v.continuation_possible);
  }
};

} // namespace message_operations
} // namespace ros

#endif // MANIPULATION_MSGS_MESSAGE_GRASPRESULT_H
