/* Software License Agreement (BSD License)
 *
 * Copyright (c) 2011, Willow Garage, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials provided
 *    with the distribution.
 *  * Neither the name of Willow Garage, Inc. nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * Auto-generated by genmsg_cpp from file /tmp/buildd/ros-hydro-manipulation-msgs-0.2.0-0precise-20150327-1930/msg/ManipulationPhase.msg
 *
 */


#ifndef MANIPULATION_MSGS_MESSAGE_MANIPULATIONPHASE_H
#define MANIPULATION_MSGS_MESSAGE_MANIPULATIONPHASE_H


#include <string>
#include <vector>
#include <map>

#include <ros/types.h>
#include <ros/serialization.h>
#include <ros/builtin_message_traits.h>
#include <ros/message_operations.h>


namespace manipulation_msgs
{
template <class ContainerAllocator>
struct ManipulationPhase_
{
  typedef ManipulationPhase_<ContainerAllocator> Type;

  ManipulationPhase_()
    : phase(0)  {
    }
  ManipulationPhase_(const ContainerAllocator& _alloc)
    : phase(0)  {
    }



   typedef int32_t _phase_type;
  _phase_type phase;


    enum { CHECKING_FEASIBILITY = 0 };
     enum { MOVING_TO_PREGRASP = 1 };
     enum { MOVING_TO_GRASP = 2 };
     enum { CLOSING = 3 };
     enum { ADJUSTING_GRASP = 4 };
     enum { LIFTING = 5 };
     enum { MOVING_WITH_OBJECT = 6 };
     enum { MOVING_TO_PLACE = 7 };
     enum { PLACING = 8 };
     enum { OPENING = 9 };
     enum { RETREATING = 10 };
     enum { MOVING_WITHOUT_OBJECT = 11 };
     enum { SHAKING = 12 };
     enum { SUCCEEDED = 13 };
     enum { FAILED = 14 };
     enum { ABORTED = 15 };
     enum { HOLDING_OBJECT = 16 };
 

  typedef boost::shared_ptr< ::manipulation_msgs::ManipulationPhase_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::manipulation_msgs::ManipulationPhase_<ContainerAllocator> const> ConstPtr;
  boost::shared_ptr<std::map<std::string, std::string> > __connection_header;

}; // struct ManipulationPhase_

typedef ::manipulation_msgs::ManipulationPhase_<std::allocator<void> > ManipulationPhase;

typedef boost::shared_ptr< ::manipulation_msgs::ManipulationPhase > ManipulationPhasePtr;
typedef boost::shared_ptr< ::manipulation_msgs::ManipulationPhase const> ManipulationPhaseConstPtr;

// constants requiring out of line definition

   

   

   

   

   

   

   

   

   

   

   

   

   

   

   

   

   



template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const ::manipulation_msgs::ManipulationPhase_<ContainerAllocator> & v)
{
ros::message_operations::Printer< ::manipulation_msgs::ManipulationPhase_<ContainerAllocator> >::stream(s, "", v);
return s;
}

} // namespace manipulation_msgs

namespace ros
{
namespace message_traits
{



// BOOLTRAITS {'IsFixedSize': True, 'IsMessage': True, 'HasHeader': False}
// {'household_objects_database_msgs': ['/opt/ros/hydro/share/household_objects_database_msgs/cmake/../msg'], 'shape_msgs': ['/opt/ros/hydro/share/shape_msgs/cmake/../msg'], 'std_msgs': ['/opt/ros/hydro/share/std_msgs/cmake/../msg'], 'actionlib_msgs': ['/opt/ros/hydro/share/actionlib_msgs/cmake/../msg'], 'sensor_msgs': ['/opt/ros/hydro/share/sensor_msgs/cmake/../msg'], 'object_recognition_msgs': ['/opt/ros/hydro/share/object_recognition_msgs/cmake/../msg'], 'geometry_msgs': ['/opt/ros/hydro/share/geometry_msgs/cmake/../msg'], 'manipulation_msgs': ['/tmp/buildd/ros-hydro-manipulation-msgs-0.2.0-0precise-20150327-1930/msg', '/tmp/buildd/ros-hydro-manipulation-msgs-0.2.0-0precise-20150327-1930/obj-x86_64-linux-gnu/devel/share/manipulation_msgs/msg']}

// !!!!!!!!!!! ['__class__', '__delattr__', '__dict__', '__doc__', '__eq__', '__format__', '__getattribute__', '__hash__', '__init__', '__module__', '__ne__', '__new__', '__reduce__', '__reduce_ex__', '__repr__', '__setattr__', '__sizeof__', '__str__', '__subclasshook__', '__weakref__', '_parsed_fields', 'constants', 'fields', 'full_name', 'has_header', 'header_present', 'names', 'package', 'parsed_fields', 'short_name', 'text', 'types']




template <class ContainerAllocator>
struct IsFixedSize< ::manipulation_msgs::ManipulationPhase_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::manipulation_msgs::ManipulationPhase_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::manipulation_msgs::ManipulationPhase_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::manipulation_msgs::ManipulationPhase_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::manipulation_msgs::ManipulationPhase_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct HasHeader< ::manipulation_msgs::ManipulationPhase_<ContainerAllocator> const>
  : FalseType
  { };


template<class ContainerAllocator>
struct MD5Sum< ::manipulation_msgs::ManipulationPhase_<ContainerAllocator> >
{
  static const char* value()
  {
    return "2c824c847a35d8fd9277d324a3723378";
  }

  static const char* value(const ::manipulation_msgs::ManipulationPhase_<ContainerAllocator>&) { return value(); }
  static const uint64_t static_value1 = 0x2c824c847a35d8fdULL;
  static const uint64_t static_value2 = 0x9277d324a3723378ULL;
};

template<class ContainerAllocator>
struct DataType< ::manipulation_msgs::ManipulationPhase_<ContainerAllocator> >
{
  static const char* value()
  {
    return "manipulation_msgs/ManipulationPhase";
  }

  static const char* value(const ::manipulation_msgs::ManipulationPhase_<ContainerAllocator>&) { return value(); }
};

template<class ContainerAllocator>
struct Definition< ::manipulation_msgs::ManipulationPhase_<ContainerAllocator> >
{
  static const char* value()
  {
    return "int32 CHECKING_FEASIBILITY = 0\n\
int32 MOVING_TO_PREGRASP = 1\n\
int32 MOVING_TO_GRASP = 2\n\
int32 CLOSING = 3 \n\
int32 ADJUSTING_GRASP = 4\n\
int32 LIFTING = 5\n\
int32 MOVING_WITH_OBJECT = 6\n\
int32 MOVING_TO_PLACE = 7\n\
int32 PLACING = 8\n\
int32 OPENING = 9\n\
int32 RETREATING = 10\n\
int32 MOVING_WITHOUT_OBJECT = 11\n\
int32 SHAKING = 12\n\
int32 SUCCEEDED = 13\n\
int32 FAILED = 14\n\
int32 ABORTED = 15\n\
int32 HOLDING_OBJECT = 16\n\
\n\
int32 phase\n\
";
  }

  static const char* value(const ::manipulation_msgs::ManipulationPhase_<ContainerAllocator>&) { return value(); }
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

  template<class ContainerAllocator> struct Serializer< ::manipulation_msgs::ManipulationPhase_<ContainerAllocator> >
  {
    template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
    {
      stream.next(m.phase);
    }

    ROS_DECLARE_ALLINONE_SERIALIZER;
  }; // struct ManipulationPhase_

} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::manipulation_msgs::ManipulationPhase_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const ::manipulation_msgs::ManipulationPhase_<ContainerAllocator>& v)
  {
    s << indent << "phase: ";
    Printer<int32_t>::stream(s, indent + "  ", v.phase);
  }
};

} // namespace message_operations
} // namespace ros

#endif // MANIPULATION_MSGS_MESSAGE_MANIPULATIONPHASE_H
